import React, { Component } from 'react';

class FormKit extends Component{
    constructor(props){
        super();
        this.props = props;
        this.state = {
            ...props.initialValue
        }
    }

    render(){
        return(
                <form className="was-validated">
                    {
                        this.props.fields.map(field => {
                            return(
                                    <div className="form-row">
                                        {
                                            field.map(element => {
                                                if(element.type == "radio"){
                                                    return(
                                                        <div className="form-check ml-2">
                                                            <input
                                                                className="form-check-input"
                                                                type="radio"
                                                                name= {element.name}
                                                                id = {element.id}
                                                                value = {element.value}
                                                                defaultChecked = {element.value == this.state[element.name]}
                                                                onChange = {e => this.setState({[element.name]: e.target.value})}
                                                            />
                                                            <label for={element.id}>{element.label}</label>
                                                        </div>
                                                    )
                                                }else if(element.type == "checkbox"){
                                                    return (
                                                        <div className="form-check ml-2">
                                                            <input 
                                                                className="form-check-input"
                                                                type="checkbox"
                                                                name={element.name}
                                                                id={element.id}
                                                                value={element.value}
                                                                defaultChecked={this.state[element.name].includes(element.value)}
                                                                onClick = {e => {
                                                                    let prevState = this.state[element.name];
                                                                    if(prevState.includes(e.target.value)){
                                                                        for(let i=0; i<prevState.length; i++){
                                                                            if(prevState[i] == e.target.value){
                                                                                prevState.splice(i, 1);
                                                                            }
                                                                        }
                                                                    }else{
                                                                        prevState.push(e.target.value);
                                                                    }

                                                                    this.setState({
                                                                        [element.name] : [...prevState]
                                                                    })
                                                                }}
                                                            />
                                                            <label for={element.id}>{element.label}</label>
                                                        </div>
                                                        
                                                    )
                                                }else{
                                                return(
                                                    <div className="form-group col text-left">
                                                        <label for={element.id} className={element.type == "radio"? "radio-inline":""}>{element.label}</label>
                                                        <input 
                                                            type="text" 
                                                            className="form-control" 
                                                            id={element.id}
                                                            name={element.name}
                                                            value={this.state[element.name]}
                                                            onChange={(e) => this.setState({[element.name]: e.target.value})}
                                                            defaultChecked = {element.value == this.state[element.name]}
                                                            required = {element.required == true ? true : false}
                                                        />
                                                    </div>
                                                )}
                                            })
                                        }
                                    </div>
                            )
                        })
                    }
                    {console.log(this.state)}
                    <div className="d-flex row">
                        <div className="col">
                            <button type="button" className={this.props.submitButton.className} onClick={async () => {
                                await this.props.onSubmit(this.state)}} >{this.props.submitButton.name}</button>
                        </div>
                    </div>
                </form>
        )
    }
}

export default FormKit;